<?php

namespace core\config;

/**
 * Interface for configuration factory.
 *
 * Configuration factory allows dynamic configuration type. This is
 * needed when there is different configuration needed for different
 * choice of implementation of one functionnality.
 */
interface ConfigurationFactory
{
	/**
	 * Build the good configuration from a given configuration array
	 *
	 * @param \array $configuration Array containing raw configuration
	 *
	 * @return \core\config\Configuration Class that inherit the
	 *                                    configuration class.
	 */
	public static function build(array $configuration) : \core\config\Configuration;
}

?>
