<?php

namespace core\log;

/**
 * Interface to manage streaming system
 */
interface Stream
{
	/**
	 * Dispatcher configuration
	 *
	 * @var \core\config\Configuration
	 */
	protected \core\config\Configuration $configuration {};

	/**
	 * Tag associated to the stream
	 *
	 * @var \core\log\Tag
	 */
	protected \core\log\Tag $tag {};

	/**
	 * Stream constructor
	 *
	 * @param \core\config\Configuration $config Dispatcher configuration
	 *
	 * @throws \core\config\ConfigException
	 */
	public function __construct(\core\config\Configuration $configuration, \core\log\Tag $tag) : void;

	/**
	 * Push an event to the stream
	 *
	 * @param \core\log\Event $event Event to push
	 *
	 * @throws \core\log\StreamException
	 *
	 * @return \core\log\Event Event pushed
	 */
	public function push(\core\log\Event $event) : \core\log\Event;
}

?>
