<?php

namespace core\plugin;

/**
 * Interface needed for every plugin
 */
interface Plugin
{
	/**
	 * Map a class name to a custom one, defined by this plugin
	 *
	 * @param \string $class_name Asked class name
	 *
	 * @return \string Custom class name
	 */
	public static function fetch_class(string $class_name) : string;

	/**
	 * Access to the plugin configuration
	 *
	 * @return \core\config\PluginConfiguration
	 */
	public static function configuration() : \core\config\PluginConfiguration;
}

?>
